# Gestion musique dans Itunes

![tag](python)
![category](utilitaire)

Je gère ma musique de façon basique: une arboresence avec un repertoire artist puis un répertoire album.

Le tag des fichiers mp3 ne correspond pas toujours à cette arboresence et les outils comme Itunes qui ne se basent
que sur les tags me donne un résultat difficile à gérer (un album dans plusieurs ...)

Pour remedier à cela j'ai écrit un script qui permet de retagger les fichiers mp3 et de les copier dans un répertoire unique
pour transfert sur l'iphone

```python
import os
from mp3_tagger import MP3File, VERSION_2, VERSION_1
from shutil import copyfile
import unicodedata

def transform(str):
    return unicodedata.normalize('NFKD', str).encode('ascii', 'ignore')

i = 0

print("change tag")
for artist in [ d for d in os.listdir('.') if os.path.isdir(d) and d not in ['iTunes','totransfert']]:
    for album in os.listdir(os.path.join('.',artist)):
        i = i+1
        for title in [ d for d in os.listdir(os.path.join('.',artist, album)) if d.endswith('.mp3')]:
            print("    ", artist, album, title)
            mp3 = MP3File(os.path.join('.',artist, album,title))
            del mp3.album
            del mp3.artist
            del mp3.band
            mp3.save()
            mp3.album = transform(album).decode("utf-8") 
            mp3.artist = transform(artist).decode("utf-8") 
            mp3.save()
            

error=False
print("check")            
for artist in [ d for d in os.listdir('.') if os.path.isdir(d) and d not in ['iTunes','totransfert']]:
    for album in os.listdir(os.path.join('.',artist)):
        for title in [ d for d in os.listdir(os.path.join('.',artist, album)) if d.endswith('.mp3')]:
            mp3 = MP3File(os.path.join('.',artist, album,title))
            if mp3.album == None or mp3.artist == None:
                error = True
                print("    error on:", artist, album, title)
                mp3.album = transform(album).decode("utf-8") 
                mp3.artist = transform(artist).decode("utf-8") 
                mp3.save()
if not error:    
    print("copy")              
    os.mkdir(os.path.join('.','totransfert'))
    for artist in [ d for d in os.listdir('.') if os.path.isdir(d) and d not in ['iTunes','totransfert']]:
        for album in os.listdir(os.path.join('.',artist)):
            i = i+1
            for title in [ d for d in os.listdir(os.path.join('.',artist, album)) if d.endswith('.mp3')]:
                copyfile(os.path.join('.',artist, album,title), os.path.join('.','totransfert', ('alb%s_' % i ) + title.replace(' ','_')))

```

et voilà

et en plus simple

```python
import os
from glob import glob
from mp3_tagger import MP3File, VERSION_2, VERSION_1
import unicodedata



def transform(str):
    return unicodedata.normalize('NFKD', str).encode('ascii', 'ignore')
    
result = [y for x in os.walk('.') for y in glob(os.path.join(x[0], '*.mp3'))]
for fil in result:
    path = os.path.abspath(fil)
    elt = path.split(os.sep)
    mp3 = MP3File(path)
    del mp3.album
    del mp3.song
    del mp3.artist
    del mp3.band
    del mp3.genre
    mp3.save()
    mp3.song = transform(elt[-1].split('.mp3')[0]).decode("utf-8") 
    mp3.album = transform(elt[-2]).decode("utf-8") 
    mp3.artist = transform(elt[-3]).decode("utf-8")
    mp3.save()
```

sinon il y a l'outil MP3Tag (https://www.mp3tag.de/en/download.html) qui permet de regenérer les tags (convertisseur Nom de fichier tag) avec pour formule %artist%\%album%\%title%